package com.ym.mec.biz.dal.dao;

import com.ym.mec.biz.dal.entity.GoodsCategory;
import com.ym.mec.biz.dal.enums.YesOrNoEnum;
import com.ym.mec.common.dal.BaseDAO;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface GoodsCategoryDao extends BaseDAO<Integer, GoodsCategory> {


    /**
     * 根据父级编号获取子列表
     * @param parentId
     * @param yesOrNoEnum
     * @return
     */
    List<GoodsCategory> findByParentId(@Param("parentId") Integer parentId, @Param("delFlag") YesOrNoEnum yesOrNoEnum);

    /**
     * @describe 获取商品分类
     * @apiNote 时光荏苒，认真工作的时间总是过得很快，而我、享受这一刻！
     * @author zouxuan
     * @date 2020/9/4
     * @time 14:05
     * @param :
     * @return java.util.List<java.util.Map<java.lang.Integer,java.lang.String>>
     */
    List<Map<String, Integer>> queryCategotyMap();
}