package com.ym.mec.biz.dal.dao;

import com.ym.mec.biz.dal.entity.Goods;
import com.ym.mec.common.dal.BaseDAO;

import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface GoodsDao extends BaseDAO<Integer, Goods> {

    /**
     * 通过科目编号查询商品(教材、辅件)列表
     *
     * @param subjectId
     * @return
     */
    List<Goods> findGoodsBySubId(@Param("subjectId") Integer subjectId, @Param("type") String type);

    /**
     * 根据商品分类查找商品数量
     *
     * @param goodsCategoryId
     * @return
     */
    int findGoodsNumByCategoryId(@Param("goodsCategoryId") Integer goodsCategoryId);

    /**
     * 根据ids获取商品信息
     *
     * @param ids
     * @return
     */
    List<Goods> findGoodsByIds(@Param("ids") String ids);

    List<Goods> findTypeGoods(@Param("type") String type);

    /**
     * @describe 批量新增
     * @apiNote 时光荏苒，认真工作的时间总是过得很快，而我、享受这一刻！
     * @author zouxuan
     * @date 2020/9/4
     * @time 14:39
     * @param goodsList:
     * @return void
     */
    void batchInsert(@Param("goodsList") List<Goods> goodsList);
}