package com.ym.mec.biz.dal.dao;


import com.ym.mec.biz.dal.dto.StudentPaymentOrderExportDto;
import com.ym.mec.biz.dal.dto.StudentPaymentRouteOrderDto;
import com.ym.mec.biz.dal.entity.StudentPaymentRouteOrder;
import com.ym.mec.biz.dal.enums.PaymentChannelEnum;
import com.ym.mec.common.dal.BaseDAO;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

public interface StudentPaymentRouteOrderDao extends BaseDAO<Long, StudentPaymentRouteOrder> {

    List<StudentPaymentRouteOrderDto> queryPageOrder(Map<String, Object> params);

    StudentPaymentRouteOrderDto getOrderMoneyAmount(Map<String, Object> params);

    /**
     * 统计充值金额
     *
     * @param params
     * @return
     */
    BigDecimal getChargeAmount(Map<String, Object> params);

    int batchAdd(@Param("routeOrders") List<StudentPaymentRouteOrder> routeOrders);

    List<StudentPaymentRouteOrder> getRouteOrders(@Param("orderNo") String orderNo);

    /**
     * 获取分部分润金额
     *
     * @param routeOrganId
     * @param paymentChannelEnumList
     * @return
     */
    BigDecimal getRouteOrderAmount(@Param("routeOrganId") Integer routeOrganId,
                                   @Param("paymentChannelEnumList") List<PaymentChannelEnum> paymentChannelEnumList,
                                   @Param("startTime") Date startTime
    );

    List<StudentPaymentOrderExportDto> ExportQueryPage(Map<String, Object> params);
}