package com.ym.mec.biz.dal.entity;

import com.ym.mec.biz.dal.enums.PaymentStatusEnum;
import com.ym.mec.common.enums.BaseEnum;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;

import java.util.Date;

/**
 * 对应数据库表(music_group_payment_calender):
 */
public class MusicGroupPaymentCalender implements Comparable<MusicGroupPaymentCalender> {

	public enum FeeType implements BaseEnum<String, FeeType> {

		OFFLINE("OFFLINE", "线下"), ONLINE("ONLINE", "线上"), ALL("ALL", "线上/线下");

		private String code;

		private String msg;

		FeeType(String code, String msg) {
			this.code = code;
			this.msg = msg;
		}

		public void setCode(String code) {
			this.code = code;
		}

		public String getMsg() {
			return msg;
		}

		public void setMsg(String msg) {
			this.msg = msg;
		}

		@Override
		public String getCode() {
			return code;
		}
	}

	/**  */
	private Long id;

	/**  */
	@ApiModelProperty(value = "乐团编号", required = false)
	private String musicGroupId;

	/** 缴费月份 */
	@ApiModelProperty(value = "缴费月份", required = false)
	private Integer paymentMonth;

	/** 开始缴费日期 */
	@ApiModelProperty(value = "开始缴费日期", required = false)
	private java.util.Date startPaymentDate;

	private Date deadlinePaymentDate;

	private PaymentStatusEnum paymentStatus;

	private Integer expectNum;

	private Integer actualNum;

	private String memo;

	private FeeType type;

	/**  */
	private java.util.Date createTime;

	/**  */
	private java.util.Date updateTime;

	private String studentIds;

	public String getStudentIds() {
		return studentIds;
	}

	public void setStudentIds(String studentIds) {
		this.studentIds = studentIds;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getId() {
		return this.id;
	}

	public void setMusicGroupId(String musicGroupId) {
		this.musicGroupId = musicGroupId;
	}

	public String getMusicGroupId() {
		return this.musicGroupId;
	}

	public void setPaymentMonth(Integer paymentMonth) {
		this.paymentMonth = paymentMonth;
	}

	public Integer getPaymentMonth() {
		return this.paymentMonth;
	}

	public void setStartPaymentDate(java.util.Date startPaymentDate) {
		this.startPaymentDate = startPaymentDate;
	}

	public java.util.Date getStartPaymentDate() {
		return this.startPaymentDate;
	}

	public void setCreateTime(java.util.Date createTime) {
		this.createTime = createTime;
	}

	public java.util.Date getCreateTime() {
		return this.createTime;
	}

	public void setUpdateTime(java.util.Date updateTime) {
		this.updateTime = updateTime;
	}

	public java.util.Date getUpdateTime() {
		return this.updateTime;
	}

	public Date getDeadlinePaymentDate() {
		return deadlinePaymentDate;
	}

	public void setDeadlinePaymentDate(Date deadlinePaymentDate) {
		this.deadlinePaymentDate = deadlinePaymentDate;
	}

	public PaymentStatusEnum getPaymentStatus() {
		return paymentStatus;
	}

	public void setPaymentStatus(PaymentStatusEnum paymentStatus) {
		this.paymentStatus = paymentStatus;
	}

	public Integer getExpectNum() {
		return expectNum;
	}

	public void setExpectNum(Integer expectNum) {
		this.expectNum = expectNum;
	}

	public Integer getActualNum() {
		return actualNum;
	}

	public void setActualNum(Integer actualNum) {
		this.actualNum = actualNum;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public FeeType getType() {
		return type;
	}

	public void setType(FeeType type) {
		this.type = type;
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this);
	}

	@Override
	public int compareTo(MusicGroupPaymentCalender cal) {
		return this.paymentMonth.compareTo(cal.getPaymentMonth());
	}

}
