package com.ym.mec.biz.service;

import com.ym.mec.biz.dal.entity.Goods;
import com.ym.mec.common.service.BaseService;

import org.apache.ibatis.annotations.Param;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

public interface GoodsService extends BaseService<Integer, Goods> {

    /**
     * 通过科目编号查询商品(教材、辅件)列表
     *
     * @param subjectId
     * @return
     */
    List<Goods> findGoodsBySubId(Integer subjectId,String type);

    /**
     * 根据商品分类id查找商品数量
     *
     * @param goodsCategoryId
     * @return
     */
    int findGoodsNumByCategoryId(@Param("goodsCategoryId") Integer goodsCategoryId);

    /**
     * 根据ids获取商品信息
     * @param ids
     * @return
     */
    List<Goods> findGoodsByIds(String ids);


    /**
     * 查询某种类型的商品
     * @param type
     * @return
     */
    List<Goods> findTypeGoods(String type);

    /**
     * @describe 商品导入
     * @apiNote 时光荏苒，认真工作的时间总是过得很快，而我、享受这一刻！
     * @author zouxuan
     * @date 2020/9/4
     * @time 11:58
     * @param file:
     * @return java.util.List<com.ym.mec.biz.dal.entity.Goods>
     */
    List<Goods> importGoods(MultipartFile file) throws Exception;
}