package com.ym.mec.biz.service;

import com.ym.mec.biz.dal.entity.MusicGroupPaymentCalender;
import com.ym.mec.biz.dal.entity.MusicGroupStudentFee;
import com.ym.mec.biz.dal.page.MusicCalenderQueryInfo;
import com.ym.mec.common.page.PageInfo;
import com.ym.mec.common.service.BaseService;

import java.util.Date;
import java.util.List;

public interface MusicGroupPaymentCalenderService extends BaseService<Long, MusicGroupPaymentCalender> {
	
	/**
	 * 创建缴费信息
	 * @param musicGroupPaymentCalender
	 * @return
	 */
	boolean create(MusicGroupPaymentCalender musicGroupPaymentCalender);
	
	/**
	 * 自动更新付款日历记录状态
	 * @return
	 */
	boolean autoUpdateMusicGroupPaymentCalenderStatus();

	/**
	 * 批量新增、修改乐团缴费周期
	 * @param musicGroupPaymentCalenders
	 */
	void batchInsert(List<MusicGroupPaymentCalender> musicGroupPaymentCalenders);

	/**
	 * 获取下次缴费时间
	 * @param musicGroupId
	 * @param latestPaidDate
	 * @return
	 */
	Date getNextPaymentDate(String musicGroupId, Date latestPaidDate, MusicGroupStudentFee fee);

	/**
	 * 修改缴费日期
	 * @param startTime
	 * @param endTime
	 * @param id
	 */
    void updateStartTime(Date startTime,Date endTime,Long id);

	/**
	 * 删除
	 * @param id
	 */
	void del(Long id);

	/**
	 * 获取明细
	 * @param id
	 * @return
	 */
    Object getDetail(Long id);

	/**
	 * 获取列表
	 * @param queryInfo
	 * @return
	 */
	PageInfo<MusicGroupPaymentCalender> queryDetailPage(MusicCalenderQueryInfo queryInfo);

	/**
	 * 推送乐团缴费提醒
	 * @param id
	 * @param userIds
	 * @return
	 */
	void paymentPush(Long id, String userIds);
}