package com.ym.mec.biz.service;

import com.ym.mec.biz.dal.dto.BasicUserDto;
import com.ym.mec.biz.dal.entity.StudentPaymentOrder;
import com.ym.mec.biz.dal.entity.StudentRepair;
import com.ym.mec.biz.dal.page.RepairStudentQueryInfo;
import com.ym.mec.common.page.PageInfo;
import com.ym.mec.common.service.BaseService;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.Map;

public interface StudentRepairService extends BaseService<Integer, StudentRepair> {

    /**
     * 根据维修技师获取相应学生列表
     */
    PageInfo<BasicUserDto> getStudents(RepairStudentQueryInfo queryInfo);

    /**
     * 添加维修单
     * @param repairInfo
     * @return
     */
   Map addRepair(StudentRepair repairInfo) throws Exception;


    /**
     * 维修完成
     * @param id
     * @param description
     */
    void repairSuccess(Integer id, String description,Integer repairStatus);

    /**
     * 获取学生信息
     * @param studentId
     * @return
     */
    BasicUserDto getStudentInfo(Integer studentId);

    /**
     * 获取维修单详情
     * @param id
     * @return
     */
    StudentRepair getRepairInfo(Integer id);

    /**
     * 支付维修单
     * @param repairInfo
     * @return
     */
    Map payRepair(StudentRepair repairInfo) throws Exception;

    /**
     * 获取学生维修技师信息
     * @param studentId
     * @return
     */
    BasicUserDto getStudentRepairer(Integer studentId,Integer organId);

    /**
     * 支付回调
     * @param order
     */
    Boolean orderCallback(StudentPaymentOrder order);
}
